variables:
    GIT_CLONE_PATH: $CI_BUILDS_DIR/$CI_COMMIT_SHORT_SHA/$CI_PROJECT_NAME
    DOCKER_DRIVER: overlay2
    DOCKER_BUILDKIT: 1

stages:
    - build
    - deploy

.build:
    stage: build
    image: docker:cli
    variables:
        GIT_STRATEGY: clone
        GIT_DEPTH: "1"
        DOCKER_HOST: tcp://docker:2376
        DOCKER_TLS_CERTDIR: "/certs"
    services:
        - name: docker:dind
          alias: docker
    before_script:
        - echo "Login to Docker Hub docker registry..."
        - echo "$DH_REGISTRY_TOKEN" && echo $DH_REGISTRY_USER
        - echo "$DH_REGISTRY_TOKEN" | docker login -u $DH_REGISTRY_USER --password-stdin
        - echo "Login to GitLab docker registry..."
        - echo "$CI_REGISTRY_PASSWORD" | docker login $CI_REGISTRY -u $CI_REGISTRY_USER --password-stdin
    only:
        - develop
        - main
    tags:
        - vasiliid
        - singapore
        - docker

build-frontend:
    extends: .build
    script:
        - cd ./frontend && docker build --build-arg ENVIRONMENT=production -t $CI_REGISTRY_IMAGE/frontend:$CI_COMMIT_SHORT_SHA -f ./Dockerfile .
        - docker push $CI_REGISTRY_IMAGE/frontend:$CI_COMMIT_SHORT_SHA 

build-backend:
    extends: .build
    script:
        - cd ./backend/express && docker build --build-arg ENVIRONMENT=production -t $CI_REGISTRY_IMAGE/backend:$CI_COMMIT_SHORT_SHA -f ./Dockerfile .
        - docker push $CI_REGISTRY_IMAGE/backend:$CI_COMMIT_SHORT_SHA 

build-artifacts:
    extends: .build
    before_script:
        - hostname
    script:
        - ls
    after_script:
        - echo "OK"
    artifacts:
        paths:
            - "*.yml"
        expire_in: 1 week


deploy:
    stage: deploy
    variables:
        GIT_STRATEGY: none
    dependencies: [build-artifacts]
    before_script:
        - echo "Login to Docker Hub docker registry..."
        - echo "$DH_REGISTRY_TOKEN" && echo $DH_REGISTRY_USER
        - echo "$DH_REGISTRY_TOKEN" | docker login -u $DH_REGISTRY_USER --password-stdin
        - echo "Login to GitLab docker registry..."
        - echo "$CI_REGISTRY_PASSWORD" | docker login $CI_REGISTRY -u $CI_REGISTRY_USER --password-stdin
    script:
        - docker compose -f docker-compose.yml up -d --force-recreate --renew-anon-volumes
    only:
        - develop
        - main
    tags:
        - vasiliid
        - singapore
        - shell

